<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
    <button (click)="newRecord(modalDatos)" class="btn btn-primary btn-shadow">
        <i class="fa fa-plus mr-2"></i>Nuevo
    </button>
    <button (click)="printPDF()" class="btn btn-danger btn-shadow ml-1">
        <i class="fa fa-file-pdf mr-2"></i>PDF
    </button>
</app-page-title>

<div class="card">
    <div class="card-body">

        <kendo-grid [data]="dataGrid" [filter]="filter" [filterable]="true" (filterChange)="filterChange($event)"
            [selectable]="true" [navigable]="true" [reorderable]="true" [resizable]="true" [sort]="sort"
            [sortable]="true" (sortChange)="sortChange($event)" (edit)="editRow($event, modalDatos)"
            (remove)="deleteRow($event)" style="height: 70vh;" *ngIf="!loading">
            <kendo-grid-column field="cUserId" title="Usuario" width="120">
            </kendo-grid-column>
            <kendo-grid-column field="cUserNomb" title="Nombre" width="180">
            </kendo-grid-column>
            <kendo-grid-column field="cUserApel" title="Apellido" width="180">
            </kendo-grid-column>
            <kendo-grid-column field="cRoles" title="Roles" [filterable]="false" media="md">
            </kendo-grid-column>
            <kendo-grid-column field="cSistemas" title="Sistemas" [filterable]="false" media="md" width="120">
            </kendo-grid-column>
            <kendo-grid-column field="Inactivo" title="Inactivo" width="120">
                <ng-template kendoGridFilterCellTemplate>
                    <kendo-switch (valueChange)="switchChange($event)" offLabel="No" [checked]="checked" onLabel="Si">
                    </kendo-switch>
                </ng-template>
                <ng-template kendoGridCellTemplate let-dataItem>
                    <input type="checkbox" [checked]="dataItem.Inactivo" disabled />
                </ng-template>
            </kendo-grid-column>
            <kendo-grid-command-column title="Actions" width="200">
                <ng-template kendoGridCellTemplate let-isNew="isNew">
                    <button kendoGridEditCommand [primary]="true">Editar</button>
                    <button kendoGridRemoveCommand>Eliminar</button>
                </ng-template>
            </kendo-grid-command-column>
        </kendo-grid>
        <app-loading *ngIf="loading"></app-loading>
    </div>
</div>

<ng-template #modalDatos let-c="close" let-d="dismiss">
    <div class="modal-header">
        <h5 class="modal-title" *ngIf="!flagEdit">Nuevo</h5>
        <h5 class="modal-title" *ngIf="flagEdit">Editar</h5>
        <button class="close" aria-label="Close" (click)="d('Cross click')">
            <span aria-hidden="true">&times;</span>
        </button>
    </div>
    <div class="modal-body">
        <kendo-tabstrip>
            <!-- TAB 1 GENERALES -->
            <kendo-tabstrip-tab [title]="'Generales'" [selected]="true">
                <ng-template kendoTabContent>
                    <form [formGroup]="formUserConf">
                        <div class="row">
                            <div class="form-group col-sm-4 col-md-4 col-lg-3">
                                <label>Código</label>
                                <input type="text" class="form-control" formControlName="cUserId" tabindex="1"
                                    [readOnly]="flagEdit">
                            </div>

                            <div class="form-group col-sm-4 col-md-4 col-lg-3">
                                <label for="cUserPwd">Password</label>
                                <input type="password" class="form-control" formControlName="cUserPwd" tabindex="2">
                            </div>
                            <div class="form-group col-sm-4 col-md-4 col-lg-3">
                                <label for="dPwdUltimo">Confirmar Password</label>
                                <input type="password" class="form-control" formControlName="dPwdUltimo" tabindex="3"
                                    [readonly]="!formUserConf.value.cUserPwd" [ngClass]="{
                                      'is-valid': formUserConf.controls.dPwdUltimo.valid,
                                      'is-invalid': formUserConf.controls.dPwdUltimo.invalid
                                    }">
                                <div class="valid-feedback" *ngIf="formUserConf.controls.dPwdUltimo.valid">
                                    Password valido!
                                </div>
                                <div class="invalid-feedback" *ngIf="formUserConf.controls.dPwdUltimo.invalid">
                                    Password invalido!
                                </div>
                            </div>
                            <div class="form-group col-sm-6 col-md-4 col-lg-4">
                                <label for="cUserNomb">Nombre</label>
                                <input type="text" class="form-control" formControlName="cUserNomb" tabindex="4">
                            </div>
                            <div class="form-group col-sm-6 col-md-4 col-lg-4">
                                <label for="cUserApel">Apellidos</label>
                                <input type="text" class="form-control" formControlName="cUserApel" tabindex="5">
                            </div>
                            <div class="form-group col-sm-6 col-md-4 col-lg-4">
                                <label for="cUserEmail">Email</label>
                                <input type="text" class="form-control" formControlName="cUserEmail" tabindex="6">
                            </div>
                            <div class="form-group col-6 col-sm-3 col-md-2 col-lg-2">
                                <label class="w-100">Inactivo</label>
                                <kendo-switch formControlName="Inactivo" [onLabel]="'Si'" [offLabel]="'No'">
                                </kendo-switch>
                            </div>
                            <div class="form-group col-6 col-sm-3 col-md-2 col-lg-1">
                                <label class="w-100">Bloquear</label>
                                <kendo-switch formControlName="lUserBlock" [onLabel]="'Si'" [offLabel]="'No'">
                                </kendo-switch>
                            </div>
                            <div class="form-group col-sm-4 col-md-4 col-lg-3">
                                <label for="dtUserAlta">Fecha Alta</label>
                                <input type="text" class="form-control" formControlName="dtUserAlta" readonly>
                            </div>
                            <div class="form-group col-sm-4 col-md-4 col-lg-3">
                                <label for="dtUserActiv">Fecha Activar</label>
                                <input type="text" class="form-control" formControlName="dtUserActiv" readonly>
                            </div>
                            <div class="form-group col-sm-4 col-md-4 col-lg-3">
                                <label for="dtUserInactiv">Fecha Inactivar</label>
                                <input type="text" class="form-control" formControlName="dtUserInactiv" readonly>
                            </div>
                        </div>
                    </form>
                </ng-template>
            </kendo-tabstrip-tab>
            <!-- TAB 2 ROLES -->
            <kendo-tabstrip-tab [title]="'Roles'">
                <ng-template kendoTabContent>
                    <div class="row">
                        <div class="form-group col-12">
                            <label for="cSistemas">Sistemas</label>
                            <kendo-multiselect name="cSistemas" [(ngModel)]="cSistemas"
                                [ngModelOptions]="{standalone: true}" [data]="dropdownSistemas" [textField]="'cSistema'"
                                [valueField]="'cSistema'" [valuePrimitive]="true">
                            </kendo-multiselect>
                        </div>
                        <div class="form-group col-12">
                            <label for="cRoles">Roles</label>
                            <kendo-multiselect name="cRoles" [(ngModel)]="cRoles" [ngModelOptions]="{standalone: true}"
                                [data]="dropdownRoles" [textField]="'cRolDesc'" [valueField]="'cRolcod'"
                                [valuePrimitive]="true">
                            </kendo-multiselect>
                        </div>
                    </div>
                </ng-template>
            </kendo-tabstrip-tab>
            <!-- TAB 3 PERFIL PMS -->
            <kendo-tabstrip-tab [title]="'Perfil PMS'">
                <ng-template kendoTabContent>
                    <form [formGroup]="formUserPms">
                        <div class="row">
                            <div class="form-group col-sm-6 col-md-4 col-lg-4">
                                <label for="Grupo">Grupo</label>
                                <kendo-combobox [data]="dsGrupos" [textField]="'Descripcion'" [valueField]="'grupo'"
                                    [valuePrimitive]="true" formControlName="Grupo" class="w-100">
                                </kendo-combobox>
                            </div>
                            <div class="form-group col-sm-6 col-md-4 col-lg-4">
                                <label for="Depto">Departamento</label>
                                <kendo-combobox [data]="dsDeptos" [textField]="'ddesc'" [valueField]="'depto'"
                                    [valuePrimitive]="true" formControlName="Depto" class="w-100">
                                </kendo-combobox>
                            </div>
                            <div class="form-group col-sm-6 col-md-4 col-lg-4">
                                <label for="Mesero">Mesero</label>
                                <kendo-combobox [data]="dsMeseros" [textField]="'mnombre'" [valueField]="'mesero'"
                                    [valuePrimitive]="true" formControlName="Mesero" class="w-100">
                                </kendo-combobox>
                            </div>
                            <div class="form-group col-sm-6 col-md-4 col-lg-4">
                                <label for="Iagrp">Ing. Agrupado</label>
                                <kendo-combobox [data]="dsIngAgrup" [textField]="'cDesc'" [valueField]="'iagrp'"
                                    [valuePrimitive]="true" formControlName="Iagrp" class="w-100">
                                </kendo-combobox>
                            </div>
                            <div class="form-group col-6 col-sm-3 col-md-4 col-lg-3 col-xl-2">
                                <label for="iMax">Máximo</label>
                                <input type="number" class="form-control" formControlName="iMax">
                            </div>
                            <div class="form-group col-6 col-sm-3 col-md-4 col-lg-3">
                                <label for="lTipo">Tipo</label>
                                <kendo-combobox [data]="dsTipos" [textField]="'tipo'" [valueField]="'tipoId'"
                                    [valuePrimitive]="true" formControlName="lTipo" class="w-100">
                                </kendo-combobox>
                            </div>
                            <div class="form-group col-6 col-sm-3 col-md-3 col-lg-3 col-xl-2">
                                <label for="lExport" class="w-100">Exportar</label>
                                <kendo-switch formControlName="lExport" [onLabel]="'Si'" [offLabel]="'No'">
                                </kendo-switch>
                            </div>
                            <div class="form-group col-6 col-sm-3 col-md-3 col-lg-3 col-xl-2">
                                <label for="lDel" class="w-100">E-Mail</label>
                                <kendo-switch formControlName="lDel" [onLabel]="'Si'" [offLabel]="'No'">
                                </kendo-switch>
                            </div>
                        </div>
                    </form>
                </ng-template>
            </kendo-tabstrip-tab>
            <!-- TAB 4 RESTRICCIONES -->
            <kendo-tabstrip-tab [title]="'Restricciones'">
                <ng-template kendoTabContent>
                    <div class="row d-flex justify-content-start">
                        <div class="row-fluid col-6 col-sm-4 col-md-3 col-lg-2 p-1"
                            *ngFor="let item of dsRestricciones">
                            <h6><strong>{{ item.nombre }}</strong></h6>
                            <div *ngFor="let opc of item.opciones;">
                                <ng-container *ngIf="opc.desc">
                                    <input type="checkbox" [id]="opc.id" [name]="opc.id" [(ngModel)]="opc.value"
                                        [ngModelOptions]="{standalone: true}" class="k-checkbox">
                                    <label [for]="opc.id" class="k-checkbox-label">{{ opc.desc }}</label>
                                </ng-container>
                            </div>
                        </div>
                    </div>
                </ng-template>
            </kendo-tabstrip-tab>
        </kendo-tabstrip>
    </div>
    <div class="modal-footer">
        <button class="btn btn-success btn-shadow px-4 py-2" (click)="guardarForm();">
            <i class="fas fa-save mr-2"></i>Guardar
        </button>
        <button class="btn btn-secondary btn-shadow px-4 py-2 ml-0" (click)="c();">
            Cerrar
        </button>
    </div>
    <!-- [disabled]="formUserConf.invalid || formUserPms.invalid" -->
</ng-template>
